#include <iostream>
#include <vector>

using namespace std;

struct my_point{
  int row;
  int col;
  bool operator==(const my_point& other){ return row == other.row && col==other.col;}
};


bool Shoot_Helper(const vector<vector<char> >& Grid, my_point cur, my_point hero, char dir){
  if(cur == hero)
    return true;
  if(Grid[cur.row][cur.col] == '*')
    return false;
  if(Grid[cur.row][cur.col] == '\\'){
    if(dir == 'N')
      dir = 'W';
    else if(dir == 'S')
      dir = 'E';
    else if(dir == 'E')
      dir = 'S';
    else if(dir == 'W')
      dir = 'N';
  }
  if(Grid[cur.row][cur.col] == '/'){
    if(dir == 'N')
      dir = 'E';
    else if(dir == 'S')
      dir = 'W';
    else if(dir == 'E')
      dir = 'N';
    else if(dir == 'W')
      dir = 'S';
  }
  my_point next = cur;
  if(dir == 'N')
    next.row--;
  if(dir == 'S')
    next.row++;
  if(dir == 'E')
    next.col++;
  if(dir == 'W')
    next.col--;
  if(next.row < 0 || next.row >=Grid.size() || next.col < 0 || next.col >= Grid[0].size())
    return false;
  return Shoot_Helper(Grid, next, hero, dir);
}
    
bool Shoot(const vector<vector<char> >& Grid, my_point laser, my_point hero){
  if(Shoot_Helper(Grid, laser, hero, 'N'))
    return true;
  if(Shoot_Helper(Grid, laser, hero, 'S'))
    return true;
  if(Shoot_Helper(Grid, laser, hero, 'E'))
    return true;
  if(Shoot_Helper(Grid, laser, hero, 'W'))
    return true;
  return false;
}
      
int main(){
  int r, c;
  int cur_case = 1;
  cin >> r >> c;
  while(r > 0){
    vector<vector<char> > Grid(r);
    my_point hero;
    my_point laser;
    vector<my_point> mirrors;
    for(int i = 0; i < r; i++){
      Grid[i].resize(c);
      for(int j = 0; j < c; j++){
	cin >> Grid[i][j];
	if(Grid[i][j] == 'I'){
	  laser.row = i;
	  laser.col = j;
	}
	if(Grid[i][j] == 'H'){
	  hero.row = i;
	  hero.col = j;
	}
	
	if(Grid[i][j] == '/' || Grid[i][j] == '\\'){
	  my_point temp;
	  temp.row = i;
	  temp.col = j;
	  mirrors.push_back(temp);
	}
      }
    }
    if(Shoot(Grid, laser, hero)){
      cout << "Case " << cur_case << ": Yes" << endl;
    }
    else{
      bool found = false;
      for(int i = 0; i < mirrors.size(); i++){
	my_point cur = mirrors[i];
	my_point temp = cur;
	char type = Grid[cur.row][cur.col];
	// north
	while(!found && temp.row >0 && Grid[temp.row-1][temp.col] == '-'){
	  Grid[temp.row][temp.col] = '-';	
	  temp.row--;
	  Grid[temp.row][temp.col] = type;
	  if(Shoot(Grid, laser, hero))
	    found = true;
	}
	Grid[temp.row][temp.col] = '-';
	// south
	temp = cur;
	while(!found && temp.row < r-1 && Grid[temp.row+1][temp.col] == '-'){
	  Grid[temp.row][temp.col] = '-';
	  temp.row++;
	  Grid[temp.row][temp.col] = type;
	  if(Shoot(Grid, laser, hero))
	    found = true;
	}
	Grid[temp.row][temp.col] = '-';
	// east
	temp = cur;
	while(!found && temp.col > 0 && Grid[temp.row][temp.col-1] == '-'){
	  Grid[temp.row][temp.col] = '-';
	  temp.col--;
	  Grid[temp.row][temp.col] = type;
	  if(Shoot(Grid, laser, hero))
	    found = true;
	}
	Grid[temp.row][temp.col] = '-';
	// west
	temp = cur;
	while(!found && temp.col < c-1 && Grid[temp.row][temp.col+1] == '-'){
	  Grid[temp.row][temp.col] = '-';
	  temp.col++;
	  Grid[temp.row][temp.col] = type;
	  if(Shoot(Grid, laser, hero))
	    found = true;
	}
	Grid[temp.row][temp.col] = '-';
	Grid[cur.row][cur.col] = type;
	if(found)
	  i = mirrors.size();
      }
      if(found)
	cout << "Case " << cur_case << ": Yes" << endl;
      else
	cout << "Case " << cur_case << ": No" << endl;
    }
    cur_case++;
    cin >> r >> c;
  }
  return 0;
}
