#include <iostream>
#include <vector>
using namespace std;

void Print_Vector(const vector<char>& v){
  for(int i = 0; i < v.size(); i++)
    cout << v[i] << " ";
  cout << endl;
}

int evaluate(vector<int> operands, vector<char> ops, int target){
  if(operands.size() != ops.size()+1)
    cout << "Operands: " << operands.size() << ", ops: " << ops.size() << endl;
  int total = 0;
  int i = 0;
  bool out_of_operands = false;
  while(i < ops.size()){
    int cur = operands[i];
    while(ops[i] == '*' && i < ops.size()){
      i++;
      cur=cur*operands[i];
    }
    total = total + cur;
    if(i == ops.size())
      out_of_operands = true;
    i++;
  }
    
  if(!out_of_operands)
    total += operands[operands.size()-1];
  return total == target;
}

// starting a new addition at pos
int Solve(const vector<int>& numbers, vector<int>& operands, vector<char>& ops, int pos, int target){
  if(pos >= numbers.size())
    return evaluate(operands, ops, target);
  
  if(pos == numbers.size()-1){
    operands.push_back(numbers[pos]);
    bool result = Solve(numbers, operands, ops, pos+1, target);
    operands.pop_back();
    return result;
  }

  //for all possible concatenations, try + and *
  int concat = 0;
  int total = 0;
  for(int i = pos; i < numbers.size()-1; i++){
    concat = 10*concat+numbers[i];
    operands.push_back(concat);
    ops.push_back('+');
    total = total + Solve(numbers, operands, ops, i+1, target);
    ops.pop_back();
    ops.push_back('*');
    total = total + Solve(numbers, operands, ops, i+1, target);
    ops.pop_back();
    operands.pop_back();
  }
  // try concatenating everything
  concat = 10*concat + numbers[numbers.size()-1];
  operands.push_back(concat);
  if(evaluate(operands, ops, target))
    total++;
  operands.pop_back();
		       
  
  return total;
}

    
  
int main(){
  
  int cur_case = 1;
  int n;
  cin >> n;
 
  while(n > 0){
    vector<int> numbers(n);
    for(int i = 0; i < n; i++)
      cin >> numbers[i];
    int target;
    cin >> target;
    vector<int> operands;
    vector<char> ops;
    int total = Solve(numbers,operands, ops,0,target);
    cout << "Case " << cur_case << ": ";
    cur_case++;
    cout << total << endl;
    cin >> n;
  }
  return 0;
}
